FROM {{image}}
MAINTAINER Priyanshu Khandelwal <priyanshu.khandelwal@cern.ch>

{% if os == "8" -%}
RUN rm -r /etc/yum.repos.d/*
{% endif -%}

ADD repos/* /etc/yum.repos.d/
ADD files/etc/pki/rpm-gpg/* /etc/pki/rpm-gpg/

{% if os == "6" -%}
RUN yum-config-manager --enable centos-sclo-rh
RUN yum-config-manager --enable slc6-cernonly
RUN yum-config-manager --enable batch6-qa
{% endif -%}

RUN yum -y update && yum clean all

{% for k, v in features.items() %}
{% if (full is defined) or ((submit is defined) and (k in submit)) %}

# {{k}}
{% if features[k+''].file is defined -%}
{% for index in features[k+''].file -%}
{% for version in index.os -%}
{% if version == os -%}
ADD {{index.source}} {{index.destination}}
{% endif -%}
{% endfor -%}
{% endfor -%}
{% endif -%}

{% if (features[k+''].pkgset is defined) and ((features[k+''].pkgset[os] is defined) or (features[k+''].pkgset.common is defined)) -%}
RUN yum{% if (features[k+''].arg is defined) and (features[k+''].arg[os] is defined) %} --{{-features[k+''].arg[os].key}} {{features[k+''].arg[os].value}}{% endif %} -y install {% if (features[k+''].pkgset.common is defined) -%} {% for pkg in features[k+''].pkgset.common %} {{-pkg}} {% endfor -%} {% endif -%} {% if (features[k+''].pkgset[os] is defined) -%} {% for pkg in features[k+''].pkgset[os] %} {{-pkg}} {% endfor -%} {% endif -%} && yum clean all
{% endif -%}

{% if (features[k+''].pkgfile is defined) and (features[k+''].pkgfile[os] is defined) -%}
ADD files/pkgs/{{features[k+''].pkgfile[os]}} .
RUN yum -y install {% if (features[k+''].arg is defined) and (features[k+''].arg[os] is defined) %}--{{-features[k+''].arg[os].key}} {% if (features[k+''].arg[os].value is defined) %} {{features[k+''].arg[os].value}}{% endif -%} {% endif -%} $(cat {{features[k+''].pkgfile[os]}}) && yum clean all
RUN rm {{features[k+''].pkgfile[os]}}
{% endif -%}

{% if features[k+''].groupadd is defined -%}
{% for index in features[k+''].groupadd -%}
{% for version in index.os -%}
{% if version == os -%}
RUN groupadd -r {{index.name}}
{% endif -%}
{% endfor -%}
{% endfor -%}
{% endif -%}

{% if features[k+''].chown is defined -%}
{% for index in features[k+''].chown -%}
{% for version in index.os -%}
{% if version == os -%}
RUN chown {% if (index.flag is defined) -%} {{index.flag}} {% endif -%} {{index.user}}:{{index.group}} {{index.path}}
{% endif -%}
{% endfor -%}
{% endfor -%}
{% endif -%}

{% if features[k+''].chmod is defined -%}
{% for index in features[k+''].chmod -%}
{% for version in index.os -%}
{% if version == os -%}
RUN chmod {% if (index.flag is defined) -%} {{index.flag}} {% endif -%} {{index.permission}} {{index.path}}
{% endif -%}
{% endfor -%}
{% endfor -%}
{% endif -%}

{% if (features[k+''].scripts is defined) and (features[k+''].scripts[os] is defined) -%}
{% for index in features[k+''].scripts[os] -%}
RUN {{index}}
{% endfor -%}
{% endif -%}

{% endif -%}
{% endfor -%}
